;***************UART baud rate calculation**********************
.equ     clock = 7372800      ;Set for uC clock frequency
.equ     baudrate = 115200      ;choose a baudrate
.equ     baudconstant = (clock/(16*baudrate))-1
;-------------------------------------------------------
USART_Init:
	clr	temp1
	out	UBRRH, temp1
	ldi	temp1, baudconstant	; set up baud rate
	out	UBRRL, temp1
	
	ldi	temp1, (1<<RXEN) | (1<<TXEN)	;Enable RX & TX
	out	UCSRB, temp1					
	ldi	temp1,(1<<URSEL) | (3<<UCSZ0)	;set frame format
	out	UCSRC, temp1			;8 data bits, 1 stop bit
	ret
;----------------------------------------------------------
getc:
	sbis   UCSRA, RXC    	 ; wait for receive complete = 1
	rjmp   getc    	  	; reading the USR clears the RXC bit

	in     u_data, UDR   ; Read Byte in UART Data Register
	ret
;----------------------------------------------------------
putc:
	sbis	UCSRA, UDRE	; wait until UDR is empty before sending another byte
				; UDRE (Uart Data Register Empty) will be set 
				; when ready to rec'v another byte
	rjmp	putc

	out	UDR, u_data	; Send byte in UART data register
	ret
;----------------------------------------------------------
	
put_string:
	lpm
	tst	r0
	breq	ps_ret			; check for end of string (0x00)
	mov	u_data,r0
	rcall	putc			; putc(char)
	adiw	ZL,1			; next char
	rjmp	put_string
ps_ret:	ret	
;----------------------------------------------------------
